#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;
in vec4 normal;

out vec4 fragColor;
void main() {
    vec4 color = texture(Sampler0, texCoord0) * vertexColor * ColorModulator;
    float desatcolor = color.g*0.59+color.r*0.3+color.b*0.11;
    vec4 finalcolor;
    finalcolor = vec4(color.r * 1, desatcolor, desatcolor, color.a);

    fragColor = linear_fog(finalcolor, vertexDistance, FogStart, FogEnd, FogColor);
}
